
#include <string.h>
#include <time.h>
#include "mcn.h"

//extern data table[256];
//extern byte conv[256];

void mcn_encrypt_seq( mpacket_t *p, int len )
{ byte *b;
	p->seq+=len;
	b=(byte*)&(p->seq);
//	b[0]=c->conv[b[0]];
//	b[1]=c->conv[b[1]];
//	b[2]=c->conv[b[2]];
//	b[3]=c->conv[b[3]];
	return;
}

void mcn_decrypt_seq( mpacket_t *p, int len )
{ byte *b;
	b=(byte*)&(p->seq);

	p->seq-=len;
	return;
}

void init_mcode( mpacket_t *p, mcode_t *c, int len )
{ gen_t g;
  byte a,b,e,d;
  int i;
	gen_set(&g,GEN_AXpB,c->table[p->data[0]],c->table[p->data[1]],len);
	a=(((int)(g.gen(&g)))*len)>>8;
	b=(((int)(g.gen(&g)))*len)>>8;
	e=(((int)(g.gen(&g)))*len)>>8;
	d=(((int)(g.gen(&g)))*len)>>8;
	gen_set(&(c->g0),GEN_AXpB,
		c->table[p->data[a]],c->table[p->data[b]],c->table[p->data[e]]+d);
	for(i=0;i<MCN_GENERATORS;i++)
	{	a=(((int)(g.gen(&g)))*len)>>8;
		b=(((int)(g.gen(&g)))*len)>>8;
		e=(((int)(g.gen(&g)))*len)>>8;
		d=(((int)(g.gen(&g)))*len)>>8;
		gen_set(&(c->g[i]),GEN_AXpB,
		     c->table[p->data[a]],c->table[p->data[b]],c->table[p->data[e]]+d);
	}
	return;
}

int mcn_encrypt_init( mpacket_t *p, mcode_t *c, int len )
{ gen_t g;
  time_t t;
  byte b;
  int i;
	t=time(NULL);
	gen_set(&g,GEN_AXpB,c->table[t&0xff],c->table[(t>>8)&0xff],t);
	while( (b=g.gen(&g))<MCN_GENERATORS );
	len=b;
	for(i=0;i<len;i++)
		p->data[i]=g.gen(&g);
	init_mcode(p,c,len);
	c->seq=SEQ_FIRST;
	return(len);
}

void mcn_decrypt_init( mpacket_t *p, mcode_t *c, int len )
{
	init_mcode(p,c,len);
	c->seq=SEQ_FIRST;
	return;
}

void mcn_encrypt( mpacket_t *p, mcode_t *c, int len )
{ byte b;
  int i,j;
	b = c->g0.gen(&(c->g0));
	b = (byte)( (((unsigned int)b)*MCN_GENERATORS)>>8 );
	b = c->g[b].gen(&(c->g[b]));
	j = (byte)( (((unsigned int)b)*len)>>8 );
	if( j>0 )
	{ byte buf[j];
		memcpy(buf,p->data,j);
		memmove(p->data,p->data+j,len-j);
		memcpy(p->data+len-j,buf,j);
	}
	for(i=0;i<len;i++)
	{	b = c->g0.gen(&(c->g0));
		b = (byte)( (((unsigned int)b)*MCN_GENERATORS)>>8 );
		p->data[i] ^= c->conv[c->g[b].gen(&(c->g[b]))];
	}
	c->seq+= len+1;
	return;
}

void mcn_decrypt( mpacket_t *p, mcode_t *c, int len )
{ byte b;
  int i,j;
	b = c->g0.gen(&(c->g0));
	b = (byte)( (((unsigned int)b)*MCN_GENERATORS)>>8 );
	b = c->g[b].gen(&(c->g[b]));
	j = (byte)( (((unsigned int)b)*len)>>8 );
	for(i=0;i<len;i++)
	{	b = c->g0.gen(&(c->g0));
		b = (byte)( (((unsigned int)b)*MCN_GENERATORS)>>8 );
		p->data[i] ^= c->conv[c->g[b].gen(&(c->g[b]))];
	}
	if( j>0 )
	{ byte buf[j];
		memcpy(buf,p->data+len-j,j);
		memmove(p->data+j,p->data,len-j);
		memcpy(p->data,buf,j);
	}
	c->seq+= len+1;
	return;
}

void mcn_decrypt_skipto( mpacket_t *p, mcode_t *c )
{ byte b;
//	c->seq=p->seq;
	while(c->seq!=p->seq)
	{	b = c->g0.gen(&(c->g0));
		b = (byte)( (((unsigned int)b)*MCN_GENERATORS)>>8 );
		c->g[b].gen(&(c->g[b]));
		c->seq++;
	}
	return;
}

