#! /bin/sh

if [ "$CC" = "" ] ; then
	export CC=gcc
fi
if [ "$LD" = "" ] ; then
	export LD=ld
fi
if [ "$CCFLAGS" = "" ] ; then
	export CCFLAGS="-Wall -O2"
fi

rm -f tables/*.o

cat <<END >tab.c
#include <stdio.h>
#include "mcn.h"
#include "tab.h"
void get_table( data **tb, byte **cv, char *ver )
{
if ( ver==NULL || (table_version!=NULL && !strcmp(table_version,ver)) )
{ *tb=table; *cv=conv; return; }
END
cat <<END >tab.h

void get_table( data **tb, byte **cv, char *ver );

END

(cd tables; ls -1 *.c) |awk 'BEGIN {n=1;}
	{ print "Compiling " $0 ;
	if ( system("cd tables; '"$CC"' '"$CCFLAGS"' -I.. -Dtable_version=table_version_" n " -Dtable=table_" n " -Dconv=conv_" n " -c " $0) != 0 )  exit(1);
	print "extern char table_version_" n "[];" >>"tab.h";
	print "extern data table_" n "[256];" >>"tab.h";
	print "extern byte conv_" n "[256];" >>"tab.h";
	print "if( table_version_" n "!=NULL && !strcmp(table_version_" n ",ver) )" >>"tab.c";
	print "{ *tb=table_" n "; *cv=conv_" n "; return; }" >>"tab.c";
	n++; } END {exit(0)}'

if [ $? -ne 0 ] ; then
	exit -1
fi

cat <<END >>tab.c
printf("Unsupported table version %s\n",ver);
*tb=table; *cv=conv; return;
}
END

echo "Compiling tab.c"
$CC $CCFLAGS -c tab.c
echo "Linking tables.o"
$LD -r -o tables.o tab.o tables/*.o

