
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <errno.h>
#include <signal.h>
#include "mcn.h"

typedef struct	{
	char	pad[2];
	char	to[6];
	char	from[6];
	unsigned short protocol;
	char	data[2048];
		} frame_t;

#define	MAX_INACTIVE_TIME	2*6	/* *10 seconds */

int g_sock;			/* spinave */
connection_t *route_c=NULL;
int route_n;

int net_ip_send( struct ip *datagram, connection_t *c, int n, int sock );
int net_send_to_peer( connection_t *c, mpacket_t *p, int l );
int send_ping( connection_t *c, unsigned int w );

int mcn_sendinit( connection_t *c )
{ char buf2[sizeof(mpacket_t)+256];
  mpacket_t *p2=(mpacket_t *)buf2;
  int l;
  	if( c->o.seq>=SEQ_FIRST && c->o.seq<=SEQ_FIRST /*+SEQ_MAXSKIP*/ )
		return(0);
	p2->seq=SEQ_INIT;
//	printf("[SEQ_INIT]->\n");
	l=mcn_encrypt_init(p2,&(c->o),256);
	mcn_encrypt_seq(p2,l);
	l+=sizeof(mpacket_t);
	net_send_to_peer(c,p2,l);
	if( c->c.seq<SEQ_FIRST || c->c.seq>SEQ_FIRST+SEQ_MAXSKIP )
		c->c.seq=SEQ_INIT;
	return(0);
}

int mcn_send( struct ip *d, connection_t *c )
{ char buf[sizeof(mpacket_t)+ntohs(d->ip_len)];
  mpacket_t *p=(mpacket_t *)buf;
  int l;
  	if( c->o.seq+ntohs(d->ip_len) > SEQ_MAX )
		c->o.seq=SEQ_INIT;
	if( c->o.seq==SEQ_INIT )
		mcn_sendinit(c);
	l=ntohs(d->ip_len);
	memcpy(&(p->data[0]),d,l);
	p->seq=c->o.seq;
//	printf("[%d]->\n",p->seq);
	mcn_encrypt(p,&(c->o),l);
	mcn_encrypt_seq(p,l);
	l+=sizeof(mpacket_t);
	net_send_to_peer(c,p,l);
	return(1);
}

int mcn_receive( mpacket_t *p, connection_t *c, frame_t *frame, int plen )
{ int len,i,j;
  unsigned int l_ip;
	c->timer = MAX_INACTIVE_TIME;
	mcn_decrypt_seq(p,plen-sizeof(mpacket_t));
//	printf("<-[%d]\n",p->seq);
	switch( p->seq )
	{	case SEQ_PING:
			send_ping(c,SEQ_PONG);
		case SEQ_PONG:
			return(0);
		case SEQ_INIT:
			mcn_decrypt_init(p,&(c->c),plen-sizeof(mpacket_t));
			mcn_sendinit(c);
			return(0);
	}
	if( c->c.seq==SEQ_INIT )
	{	mcn_sendinit(c);
//		printf("need INIT\n");
		return(0);
	}
	if( p->seq < c->c.seq )
	{	
		for(j=-1,i=0;i<MAX_IWIN;i++)
		{	if( c->iwin[i].seq==SEQ_INIT ) continue;
			if( c->iwin[i].seq<=p->seq )
			{	if( j<0 || c->iwin[i].seq>c->iwin[j].seq )
				{	j=i;
					if( c->iwin[j].seq==p->seq )
						break;
				}
			}
		}
		if( j>=0 )
		{	mcn_decrypt(p,&(c->iwin[j]),plen-sizeof(mpacket_t));
		}
		else
		{	//printf("p->seq=%d c->seq=%d\n",p->seq,c->c.seq);
			return(0);
		}
	}
	else if( p->seq > c->c.seq )
	{	if( p->seq - c->c.seq > SEQ_MAXSKIP )
		{	mcn_sendinit(c);
			//printf("skip>maxskip\n");
			return(0);
		}
		for(j=0,i=0;i<MAX_IWIN;i++)
		{	if( c->iwin[i].seq==SEQ_INIT )
			{	j=i;	break;	}
			if( c->iwin[i].seq < c->iwin[j].seq )
				j=i;
		}
		c->iwin[j]=c->c;
		//printf("skipping %d to %d\n",c->c.seq,p->seq);
		mcn_decrypt_skipto(p,&(c->c));
		mcn_decrypt(p,&(c->c),plen-sizeof(mpacket_t));
	}
	else	mcn_decrypt(p,&(c->c),plen-sizeof(mpacket_t));
	
//	memset(frame->pad,0xff,2+6+6);
	memset(frame->pad,0x00,2+6+6);
	frame->from[0]=0xfe;
	frame->from[1]=0xfd;
	frame->to[0]=0xfe;
	frame->to[1]=0xfd;
//	frame->pad[0]=0;
//	frame->pad[1]=0;
	frame->protocol=htons(0x0800);
	len=ntohs( ((struct ip *)(&(p->data)))->ip_len );

	l_ip=ntohl( ((struct ip *)(&(p->data)))->ip_dst.s_addr );
	if( (c->l_vip & c->l_vmask)!=(l_ip & c->l_vmask) )
	{	if( route_c==NULL || !(c->flags & F_ROUTE) )
			return(0);
		net_ip_send((struct ip *)(&(p->data)),route_c,route_n,g_sock);
		return(0);
	}

//{ struct iphdr *i;
//	i=(struct iphdr *)(&(p->data));
//	printf("IP: saddr=%x daddr=%x protocol=%x tos=%x\n",i->saddr,i->daddr,i->protocol,i->tos);
//	vypis(i,len);
//}

	
	if( len>2048 )	return(0);
	memcpy(frame->data, &(p->data), len);
	len+=16;
	return(len);
}

int net_send_to_peer( connection_t *c, mpacket_t *p, int l )
{ struct sockaddr_in sa;

	c->timer = MAX_INACTIVE_TIME;
#ifdef ALLOW_TCP
	if( c->tcp_socket==TCP_DISABLE )
	{
#endif
		sa.sin_family = AF_INET;
		sa.sin_addr.s_addr= htonl(c->r_rip);
		sa.sin_port=htons(c->r_rport);
		sendto(g_sock,p,l,0,(struct sockaddr *)(&sa),
		     sizeof(struct sockaddr_in) );
//printf("Poslane (l=%d)\n",l);
		return(0);
#ifdef ALLOW_TCP
	}
	if( c->tcp_socket>=0 )
	{	mcn_decrypt_seq(p,l-sizeof(mpacket_t));
		if( p->seq==SEQ_INIT )
		{	p->seq=1;
			write(c->tcp_socket,p,sizeof(mpacket_t));
//printf("TCP: sending INIT\n");
		}
		else if( p->seq==SEQ_PING || p->seq==SEQ_PONG )
		{	p->seq=0;
			write(c->tcp_socket,p,sizeof(mpacket_t));
			return(0);
		}
//else printf("TCP: sending packet\n");
		p->seq=l;
		write(c->tcp_socket,p,l);
		return(0);
	}
	return(0);
#endif
}

int send_ping( connection_t *c, unsigned int w )
{ mpacket_t p;
	p.seq=w;
	mcn_encrypt_seq(&p,0);
	return(net_send_to_peer(c,&p,sizeof(mpacket_t)));
}

int net_ip_send( struct ip *datagram, connection_t *c, int n, int sock )
{ int i;
  unsigned long to;
  struct ipmask_s *ipm;
  	to=ntohl(datagram->ip_dst.s_addr);
	for(i=0;i<n;i++)
	{	for(ipm=c[i].r_vip;ipm!=NULL;ipm=ipm->next)
		{	if( (ipm->ip & ipm->mask)==(to & ipm->mask) )
			{	mcn_send(datagram,c+i);
				return(1);
			}
		}
	}
//	printf("No route n=%d to=%lx\n",n,to);
	return(0);
}

int net_received( char *buf, struct sockaddr_in *sa, int len, connection_t *c, int n, frame_t *frame )
{ int i;
  unsigned int from;
  unsigned short port;
	if( sa->sin_family != AF_INET )
		return(-1);
	from=ntohl(sa->sin_addr.s_addr);
	port=ntohs(sa->sin_port);
	for(i=0;i<n;i++)
	{	if( (c[i].r_rip & c[i].r_rmask)==(from & c[i].r_rmask)
		&& ((c[i].flags&F_DPORT)||(c[i].r_rport==port)) )
		{	if( c[i].r_rip!=from )
			{	c[i].r_rip=from;
				c[i].c.seq=SEQ_INIT;
				c[i].o.seq=SEQ_INIT;
			}
			c[i].r_rport=port;
			return(mcn_receive((mpacket_t*)buf,c+i,frame,len));
		}
	}
	//printf("Invalid sender\n");
	return(0);
}

#ifdef ALLOW_TCP
int net_accept( int s, struct sockaddr_in *sa, connection_t *c, int n )
{ int i;
  unsigned int from;
  unsigned short port;
	if( sa->sin_family != AF_INET )
		return(-1);
	from=ntohl(sa->sin_addr.s_addr);
	port=ntohs(sa->sin_port);
	for(i=0;i<n;i++)
	{	if( (c[i].r_rip & c[i].r_rmask)==(from & c[i].r_rmask)
		/* && ((c[i].flags&F_DPORT)||(c[i].r_rport==port))*/
		&& (c[i].tcp_socket==TCP_ENABLE || c[i].tcp_socket>=0) )
		{	if( c[i].tcp_socket>=0 )
			{	if( c[i].r_rip!=from )
					break;
				close(c[i].tcp_socket);
			}
			if( c[i].r_rip!=from )
				c[i].r_rip=from;
			c[i].c.seq=SEQ_INIT;
			c[i].o.seq=SEQ_INIT;
			c[i].tcp_socket_t=c[i].tcp_socket;
			c[i].tcp_socket=s;
			c[i].tcp_state=0;
			c[i].tcp_bufpos=0;
			return(0);
		}
	}
	return(-1);
}

/* tcpread : read data to length len
 * return : 1 - readed
 *          0 - unfinished
 *          -1 - error or eof
 */
int tcpread( connection_t *c, int len )
{ int r,l;
	if( (l=len - c->tcp_bufpos)<=0 )
		return(1);
	r=read(c->tcp_socket,c->tcp_buf+c->tcp_bufpos,l);
	if( r<0 )
	{	if( errno==EAGAIN )
			return(0);
		return(-1);
	}
	if( r==0 )
		return(-1);	/* EOF */
	c->tcp_bufpos+=r;
	if( (len - c->tcp_bufpos)<=0 )
		return(1);
	return(0);
}

int net_tcp_received( char *buf, connection_t *c, frame_t *frame )
{ int r;
  unsigned int len;
  	if( c->tcp_bufpos < sizeof(mpacket_t) )
	{	if( (r=tcpread(c,sizeof(mpacket_t)))<=0 )
			return(r);
		if( ((mpacket_t*)(c->tcp_buf))->seq == 0 )	/* ping */
		{	c->tcp_state=0;
			c->tcp_bufpos=0;
			/* musim zahodit sam, lebo na to uz nesmie ist PONG */
			return(0);
		}
		if( ((mpacket_t*)(c->tcp_buf))->seq == 1 )
		{	c->tcp_state=1;
			c->tcp_bufpos=0;
//printf("TCP: received INIT\n");
			return(0);
		}
	}
	if( (len=((mpacket_t*)(c->tcp_buf))->seq)>=2048 )
	{	c->tcp_state=0;
		c->tcp_bufpos=0;
		return(-1);
	}
	if( (r=tcpread(c,len))<=0 )
		return(r);

	if( c->tcp_state )
		((mpacket_t*)(c->tcp_buf))->seq=SEQ_INIT;
	else if( c->c.seq!=SEQ_INIT )
		((mpacket_t*)(c->tcp_buf))->seq=c->c.seq;
	else	((mpacket_t*)(c->tcp_buf))->seq=SEQ_INIT+1;
	c->tcp_state=0;
	c->tcp_bufpos=0;
	mcn_encrypt_seq((mpacket_t*)(c->tcp_buf),len-sizeof(mpacket_t));
	return(mcn_receive((mpacket_t*)(c->tcp_buf),c,frame,len));
}
#endif

void set_nblock(sock)
{ int r;
	r=fcntl(sock,F_GETFL,0);
	fcntl(sock,F_SETFL,r|O_NONBLOCK);
}
void set_block(sock)
{ int r;
	r=fcntl(sock,F_GETFL,0);
	fcntl(sock,F_SETFL,r&(~O_NONBLOCK));
}

int main_loop( connection_t *c, int n, int port, char *dev )
{ int i,l;
  int tap;
  frame_t frame;
  char buf[2048];
  struct ip *datagram;
  int sock,sal;
#ifdef ALLOW_TCP
  int tcp;
#endif
  struct sockaddr_in sa;
  fd_set rd;
  int max,f_max;
  int tick=1;
  struct timeval tv;
#ifdef USE_TIMEOFDAY
  struct timeval tv10;
#endif

  	if( (tap=open(dev,O_RDWR))<0 )
	{	printf("Can't open %s\n",dev);
		return(-1);
	}
	if( (sock=socket(PF_INET,SOCK_DGRAM,0))<0 )
	{	printf("Can't open udp socket\n");
		close(tap);
		return(-1);
	}
	i=1;
	setsockopt(sock,SOL_SOCKET,SO_REUSEADDR,&i,sizeof(i));
#ifdef ALLOW_TCP
	if( (tcp=socket(PF_INET,SOCK_STREAM,0))<0 )
	{	printf("Can't open tcp socket\n");
		close(sock);
		close(tap);
		return(-1);
	}
	i=1;
	setsockopt(tcp,SOL_SOCKET,SO_REUSEADDR,&i,sizeof(i));
#endif
	sa.sin_family = AF_INET;
	sa.sin_addr.s_addr= INADDR_ANY;
	sa.sin_port=htons(port);
	if( bind(sock,(struct sockaddr*)&sa,sizeof(struct sockaddr_in))<0 )
	{	printf("Can't bind udp socket\n");
		close(sock);
#ifdef ALLOW_TCP
		close(tcp);
#endif
		close(tap);
		return(-1);
	}
	listen(sock,8);
#ifdef ALLOW_TCP
	if( bind(tcp,(struct sockaddr*)&sa,sizeof(struct sockaddr_in))<0 )
	{	printf("Can't bind tcp socket\n");
		close(sock);
		close(tcp);
		close(tap);
		return(-1);
	}
	listen(tcp,8);
#endif
	g_sock=sock;
	route_c=c;
	route_n=n;
	FD_ZERO(&rd);
	max=sock;
 	if( tap>max ) max=tap;
#ifdef ALLOW_TCP
	if( tcp>max ) max=tcp;
#endif
	f_max=max;
#ifdef USE_TIMEOFDAY
	gettimeofday(&tv10,NULL);
#endif
	for(;;)
	{	max=f_max;
		FD_ZERO(&rd);
		FD_SET(tap,&rd);
		FD_SET(sock,&rd);
#ifdef ALLOW_TCP
		if( tcp>=0 )	FD_SET(tcp,&rd);
#endif
		for(i=0;i<n;i++)
		{	
#ifdef ALLOW_TCP
			switch( c[i].tcp_socket )
			{	case TCP_ENABLE:
					break;
				case TCP_DISABLE:
#endif
					if( c[i].flags & F_ACTIVE )
					{	if( TIMER(c[i].timer,tick) )
							send_ping(c+i,SEQ_PING);
					}
#ifdef ALLOW_TCP
					break;
				case TCP_CONNECT:
					if( c[i].timer )
					{	if( ! TIMER(c[i].timer,tick) )
							break;
					}
					c[i].tcp_socket_t=c[i].tcp_socket;
					if( (c[i].tcp_socket=socket(PF_INET,SOCK_STREAM,0))<0 )
					{	c[i].tcp_socket=TCP_CONNECT;
						break;
					}
					c[i].tcp_state=0;
					c[i].tcp_bufpos=0;
					sa.sin_family = AF_INET;
					sa.sin_addr.s_addr= htonl(c[i].r_rip);
					sa.sin_port=htons(c[i].r_rport);
					set_nblock(c[i].tcp_socket);
					if( connect(c[i].tcp_socket,(struct sockaddr*)(&sa),sizeof(struct sockaddr_in))<0 && errno!=EINPROGRESS )
					{	c[i].tcp_socket=TCP_CONNECT;
						break;
					}
				default:
					FD_SET(c[i].tcp_socket,&rd);
					if( c[i].tcp_socket>max ) max=c[i].tcp_socket;
					if( TIMER(c[i].timer,tick) )
						send_ping(c+i,SEQ_PING);
			}
#endif
		}

		if( tick )
		{	tv.tv_sec = 10;
			tv.tv_usec = 0;
#ifdef USE_TIMEOFDAY
			tv10.tv_sec+=10;
#endif
		}
#ifdef USE_TIMEOFDAY
		gettimeofday(&tv,NULL);
		if( (tv.tv_sec = tv10.tv_sec - tv.tv_sec)<0 )
		{	tv.tv_sec = 0;
			tv.tv_usec = 0;
		}
		else if( (tv.tv_usec = tv10.tv_usec - tv.tv_usec)<0 )
		{	tv.tv_usec += 1000000;
			if( tv.tv_sec > 0 )	tv.tv_sec -= 1;
		}
#endif
		if( select(max+1,&rd,NULL,NULL,&tv)<=0 ||
		    ( tv.tv_sec==0 && tv.tv_usec==0 ) )
			tick=1;
		else	tick=0;
		if( FD_ISSET(tap,&rd) )
		{	
#ifdef FRAME
			if( (l=read(tap,&frame,sizeof(frame)))==0 )
				break;
//			printf("tap0 (pad=%d) ->\n",frame.pad[0]|(frame.pad[1])<<8);
			if( l>0 && frame.protocol==htons(0x0800) )
			{	
#else
				if( (l=read(tap,&(frame.data),2048))==0 )
					break;
#endif
				datagram=(struct ip *)(&(frame.data));
//				printf("IP %08x -> %08x len=%d (%d)\n",
//					datagram->ip_src.s_addr,
//					datagram->ip_dst.s_addr,
//					ntohs(datagram->ip_len),l);
//				vypis((char*)datagram,ntohs(datagram->ip_len));
				net_ip_send(datagram,c,n,sock);
#ifdef FRAME
			}
#endif
		}
		if( FD_ISSET(sock,&rd) )
		{	sal=sizeof(struct sockaddr_in);
			if( (l=recvfrom(sock,&buf,2048,0,(struct sockaddr*)&sa,
					&sal))>0 )
			{
//				 printf("siet (l=%d)\n",l);
				if( (l=net_received(buf,&sa,l,c,n,&frame))>0 )
#ifdef FRAME
					write(tap,&frame,l);
#else
					write(tap,&(frame.data),ntohs(((struct ip *)(&(frame.data)))->ip_len));
#endif
//	printf("->tap0 (l=%d) (pad=%d)\n",l,frame.pad[0]|(frame.pad[1])<<8);
			}
		}
#ifdef ALLOW_TCP
		if( FD_ISSET(tcp,&rd) )
		{ int s;
			sal=sizeof(struct sockaddr_in);
			if( (s=accept(tcp,(struct sockaddr*)&sa,&sal))>=0 )
			{	net_accept(s,&sa,c,n);
			}
		}
		for(i=0;i<n;i++)
		{	if( c[i].tcp_socket>=0 && FD_ISSET(c[i].tcp_socket,&rd) )
			{	
				if( (l=net_tcp_received(buf,c+i,&frame))>0 )
#ifdef FRAME
					write(tap,&frame,l);
#else
					write(tap,&(frame.data),ntohs(((struct ip *)(&(frame.data)))->ip_len));
#endif
				else if( l<0 )
				{	close(c[i].tcp_socket);
					c[i].tcp_socket=c[i].tcp_socket_t;
//printf("TCP: tcp_socket=%d\n",c[i].tcp_socket);
					if( c[i].tcp_socket==TCP_CONNECT )
						c[i].timer=3;
					else	c[i].timer=0;
				}
			}
		}
#endif
	}
	close(sock);
	close(tap);
#ifdef ALLOW_TCP
	if( tcp>=0 )	close(tcp);
#endif
	return(0);
}

int main( int argc, char *argv[] )
{ connection_t *ctab;
  int i,a;
  int port=MCN_PORT;
#ifdef linux
  char *dev="/dev/tap0";
#else
  char *dev="/dev/tun0";
#endif
  char *rt="/etc/mcntab";
	a=1;
	while( a<argc )
	{	if( a+1<argc && !strcmp(argv[a],"-p") )
		{	a++;
			port=atoi(argv[a]);
		}
		else if( a+1<argc && !strcmp(argv[a],"-t") )
		{	a++;
			dev=argv[a];
		}
		else if( a+1<argc && !strcmp(argv[a],"-r") )
		{	a++;
			rt=argv[a];
		}
		else if( a<argc && !strncmp(argv[a],"-h",2) )
		{	printf("Marek's Crypted Network (c)2001 ver.0.4 ["
#ifdef FRAME
			" frame"
#else
			" noframe"
#endif
#ifdef ALLOW_TCP
			" +tcp"
#endif
			" ]\n"
			"by Marek Zelem <marek@terminus.sk>\n"
			"\nUsage: %s [-p <port>] [-t <tap/tunel device>]"
				" [-r <mcntable>]\n"
			" port - mcn port ( %d )\n"
			" tap/tunel device ( %s )\n"
			" mcntable - mcn route table ( %s )\n",
				argv[0],port,dev,rt);
			exit(0);
		}
		a++;
	}

	if( (ctab=reat_ctab(rt))==NULL )
	{	printf("Error in mcn route table (file %s)\n",rt);
		return(0);
	}
	for(i=0;ctab[i].c.seq!=(unsigned int)(-1);i++);

	signal(SIGPIPE,SIG_IGN);
	
	return( main_loop(ctab,i,port,dev) );
}


