
#include "generator.h"

#define	MCN_PORT	234

#define	MCN_GENERATORS	16

#ifndef FRAME
#ifndef NOFRAME
#ifdef linux
#define FRAME
#else
#define NOFRAME
#endif
#endif
#endif

/* For nonlinux default enabled, because select not return remaining timeout */
#ifndef linux
#define USE_TIMEOFDAY
#endif

typedef struct	{
	data		*table;
	byte		*conv;
	unsigned int	seq;
	gen_t		g0;
	gen_t		g[MCN_GENERATORS];
		} mcode_t;

#define	MAX_IWIN	16

struct ipmask_s	{
	struct ipmask_s	*next;
	unsigned int	ip;		/* ip */
	unsigned int	mask;		/* mask */
		};

typedef struct	{
	unsigned int	seq;
	unsigned char	data[0];
		} mpacket_t;

#define	SEQ_INIT	0x00000000
#define	SEQ_FIRST	0x00000001
#define	SEQ_MAXSKIP	2048
#define	SEQ_MAX		0xffffffef
#define	SEQ_PING	0xfffffff1
#define	SEQ_PONG	0xfffffff2

#ifdef ALLOW_TCP
#define	TCP_DISABLE	-3
#define	TCP_ENABLE	-2
#define	TCP_CONNECT	-1
#endif
typedef struct	{
	unsigned int	r_rip;		/* remote real ip */
	unsigned int	r_rmask;	/* remote real mask */
	struct ipmask_s	*r_vip;		/* remote virtual ip + mask */
	unsigned int	r_serial;	/* remote serial no. ?UNUSED? */
	unsigned int	r_rport;	/* remote real UDP port */
	unsigned int	l_vip;		/* local virtual ip */
	unsigned int	l_vmask;	/* local virtual mask */
#ifdef ALLOW_TCP
	int		tcp_socket;	/* TCP_xxx, alebo socket */
	int		tcp_socket_t;	/* temp. */
	int		tcp_state;
	int		tcp_bufpos;
	char		tcp_buf[2048];	/* input TCP buffer */
#endif
	int		timer;		/* *10 sec */
	int		flags;
	int		allow_route;	/* 1 - allow route */
	/* password */
	mcode_t		c;
	mcode_t		o;		/* output c-state */
	mcode_t		iwin[MAX_IWIN];
//	int		sock;		/* socket for sending */
		} connection_t;
#define	F_ACTIVE	0x01
#define	F_ROUTE		0x02
#define	F_DPORT		0x04

#define	TIMER(t,tick)	((t)==0 || ((tick)&&(--(t)==0)))

connection_t *reat_ctab( char *filename );

void mcn_encrypt_seq( mpacket_t *p, int len );
void mcn_decrypt_seq( mpacket_t *p, int len );
int mcn_encrypt_init( mpacket_t *p, mcode_t *c, int len );
void mcn_decrypt_init( mpacket_t *p, mcode_t *c, int len );
void mcn_encrypt( mpacket_t *p, mcode_t *c, int len );
void mcn_decrypt( mpacket_t *p, mcode_t *c, int len );
void mcn_decrypt_skipto( mpacket_t *p, mcode_t *c );

extern char table_version[];
extern data table[256];
extern byte conv[256];

