
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/un.h>
#include <sys/types.h>
#include <fcntl.h>
#include "mcn.h"
#include "tab.h"

/* /etc/mcntab file format:
r_vip[/r_vmask][,r_vip[/r_vmask]]... r_rip[/r_rmask][:tcp|:connect][:route][:<port>][:dport][:active] l_vip[/l_vmask] [table_version]
 */

#define	iaddr_c2i(c)	(*(int *)(c));
int name2ip(char *name, unsigned int *ip)
{ struct hostent *he;
	if(!name[0])
	{	*ip=(unsigned int)inet_addr ("127.0.0.1");
		return(1);
	}
	if( (*ip=(unsigned int)inet_addr(name))!=(unsigned int)(-1) )
	return(1);
	if( (he=gethostbyname(name))==NULL )
		return(0);
	*ip=(unsigned int)iaddr_c2i(he->h_addr);
	return(1);
}

int get_ip_mask( char *w, unsigned int *ip, unsigned int *mask )
{ char *m;
	m=w;
	while( *m!=0 && *m!='/' )	m++;
	if( *m!=0 )	*m++=0;
	if( !name2ip(w,ip) )
		return(-1);
	if( *ip==~0 )	return(-1);
	*ip=ntohl(*ip);
	if( *m==0 )	*mask=~0;
	else if( strchr(m,'.')!=NULL )
		*mask=ntohl((unsigned int)inet_addr(m));
	else
	{ int n;
		n=atoi(m);
		*mask= (((1<<n)-1)<<(32-n));
	}
	return(0);
}

connection_t *reat_ctab( char *filename )
{ FILE *f;
  char s[1024],*p,*w;
  static connection_t ctab[128];
  unsigned int ip,mask;
  int n,i,ciarka,dvojbodka;
  struct ipmask_s *ipm;
  data *tb;
  byte *cv;
  int line=0;
	if( (f=fopen(filename,"r"))==NULL )
	{	printf("Can't open %s !\n",filename);
		return(NULL);
	}
	n=0;
	while( fgets(s,1023,f)!=NULL )
	{	line++;
		if( s[0]!=0 && s[strlen(s)-1]=='\n' )
			s[strlen(s)-1]=0;
		p=s;
		while( *p==' ' || *p=='\t' )	p++;
		if( *p==0 || *p=='#' )	continue;
		ciarka=0;
		ctab[n].r_rport=MCN_PORT;
#ifdef ALLOW_TCP
		ctab[n].tcp_socket= TCP_DISABLE;
		ctab[n].tcp_socket_t= TCP_DISABLE;
		ctab[n].tcp_state= 0;
		ctab[n].tcp_bufpos= 0;
#endif
		ctab[n].timer=0;
		ctab[n].flags=0;
		ctab[n].r_vip=NULL;
next:		w=p;
		while( *p!=0 && *p!=' ' && *p!='\t' && *p!=',')	p++;
		if( *p==0 )	goto Error;
		if( *p==',' )	ciarka=1;
		*p++=0;
		if( get_ip_mask(w,&ip,&mask)<0 )	goto Error;
		if( (ipm=malloc(sizeof(struct ipmask_s)))==NULL )
							goto Error;
		ipm->ip=ip; ipm->mask=mask;
		ipm->next=ctab[n].r_vip;
		ctab[n].r_vip=ipm;
		while( *p==' ' || *p=='\t' )	p++;
		if( *p==',' )
		{	ciarka=1; p++;
			while( *p==' ' || *p=='\t' )	p++;
		}
		if( ciarka ) goto next;
		dvojbodka=0;
		w=p;
		while( *p!=0 && *p!=' ' && *p!='\t' && *p!=':' )	p++;
		if( *p==0 )	goto Error;
		if( *p==':' )	dvojbodka=1;
		*p++=0;
		if( get_ip_mask(w,&ip,&mask)<0 )	goto Error;
		ctab[n].r_rip=ip; ctab[n].r_rmask=mask;
		
		while( dvojbodka )
		{	dvojbodka=0;
			w=p;
			while( *p!=0 && *p!=' ' && *p!='\t' && *p!=':' )
				p++;
			if( *p==0 )	goto Error;
			if( *p==':' )	dvojbodka=1;
			*p++=0;
			if( *w>='0' && *w<='9' )
				ctab[n].r_rport=atoi(w);
			else if( !strcasecmp(w,"route") )
			{	ctab[n].flags|=F_ROUTE;
			}
			else if( !strcasecmp(w,"active") )
			{	ctab[n].flags|=F_ACTIVE;
			}
			else if( !strcasecmp(w,"dport") )
			{	ctab[n].flags|=F_DPORT;
			}
#ifdef ALLOW_TCP
			else if( !strcasecmp(w,"tcp") )
			{	if( ctab[n].tcp_socket==TCP_DISABLE )
					ctab[n].tcp_socket= TCP_ENABLE;
			}
			else if( !strcasecmp(w,"connect") )
				ctab[n].tcp_socket= TCP_CONNECT;
#endif
			else goto Error;
		}

		while( *p==' ' || *p=='\t' )	p++;
		w=p;
		while( *p!=0 && *p!=' ' && *p!='\t' )	p++;
//		if( *p==0 )	goto Error;
		if( *p!=0 )	*p++=0;
		if( get_ip_mask(w,&ip,&mask)<0 )	goto Error;
		ctab[n].l_vip=ip; ctab[n].l_vmask=mask;
		ctab[n].r_serial=0;
		if( *p==0 )
		{	get_table(&tb,&cv,NULL);
		}
		else
		{	w=p;
			while( *p!=0 && *p!=' ' && *p!='\t' )	p++;
			if( *p!=0 )	*p++=0;
			get_table(&tb,&cv,w);
		}
		ctab[n].c.seq=SEQ_INIT;
		ctab[n].c.table=tb;
		ctab[n].c.conv=cv;
		ctab[n].o.seq=SEQ_INIT;
		ctab[n].o.table=tb;
		ctab[n].o.conv=cv;
		for(i=0;i<MAX_IWIN;i++)
		{	ctab[n].iwin[i].seq=SEQ_INIT;
			ctab[n].iwin[i].table=tb;
			ctab[n].iwin[i].conv=cv;
		}
		n++;
	}
	fclose(f);
	ctab[n].c.seq=(unsigned int)(-1);
	ctab[n].o.seq=(unsigned int)(-1);
	return(ctab);
Error:
	printf("format of %s at line %d is invalid!\n",filename,line);
	fclose(f);
	return(NULL);
}

