

#include <stdio.h>
#include <time.h>
#include <stdlib.h>


int skip_lines( int i )
{ char buf[128];
	while( i>0 )
	{	if( fgets(buf,128,stdin)==NULL )	return(-1);
		i--;
	}
	return(0);
}

unsigned long get_number( void )
{ unsigned long d;
  char buf[128];
	if( fgets(buf,128,stdin)==NULL )	return(0);
	d=0;
	sscanf(buf,"%ld",&d);
	return(d);
}

unsigned long get_good_number( void )
{ unsigned long d;
	do {	if( (d=get_number())==0 )	return(0);
	   } while( ((d+1)&0x03l)==0 );
	return( d );
}

int main( void )
{ int i,j;
  time_t t;
  unsigned long table[256];

	time(&t);
	srand( (unsigned int)t );
	fprintf(stdout,	"/* table for mcode generated by table_generator\n"
			" * %s */\n\n#include \"generator.h\"\n\n"
			"char table_version[]=\"V1_%ld\";\n\n"
			"data table[256]=\n{\n",ctime(&t),t);
//	skip_lines(65536*8);
	for(i=0;i<256;i++)
	{	j= (rand()&0x0ff) | ((rand()&0x0ff)<<8);
		j= j % /*1024*/ 4096;
		skip_lines( j );
		if( (table[i]=get_good_number())==0 )
		{	fprintf(stderr,"Can't read input file\n");
			return(-1);
		}
	}
	for(i=0;i<256;i++)
	{	if( (i&0x07)==0 && i!=0 )	fprintf(stdout,",\n");
		else if( i!=0 )			fprintf(stdout,", ");
		j= (rand()&0x0ff);
		while( table[j] == 0 )	j= (j+1) % 256;
		fprintf(stdout,"%ld",table[j]);
		table[j]=0;
	}
	fprintf(stdout,"\n};\n\nbyte conv[256]=\n{\n");
	for(i=0;i<256;i++)
	{	if( (i&0x0f)==0 && i!=0 )	fprintf(stdout,",\n");
		else if( i!=0 )			fprintf(stdout,", ");
		j= (rand()&0x0ff);
		while( table[j] != 0 )	j= (j+1) % 256;
		fprintf(stdout,"%3d",j);
		table[j]=1;
	}
	fprintf(stdout,"\n};\n\n/* table end */");
	return(0);
}

